#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Green
#property indicator_color2 Aqua
#property indicator_color3 Blue
#property indicator_color4 Yellow
#property indicator_color5 Red
#property indicator_width5 2
#property indicator_color6 Lime
#property indicator_width6 2

string Gs_unused_76 = "*";
string Gs_unused_84 = "*";
string Gs_unused_92 = "*";
string Gs_unused_100 = "*";
string Gs_unused_108 = "*";
string Gs_unused_116 = "*";
int Gi_124 = 20;
int Gi_128 = 35;
extern string note1 = "*Inform*";
extern color HighLine_Color = DarkGray;
extern color ZeroLine_Color = DarkGray;
extern color LowLine_Color = DarkGray;
extern int Line_Style = 2;
extern string note2 = "*Colors*";
extern color text1Color = Silver;
extern color text2Color = Silver;
extern color text3Color = Green;
extern int Shift_UP_DN = 10;
extern int Shift_Left_Right = 50;
extern string note3 = "* Alert You *";
extern bool MsgAlerts = FALSE;
extern bool SoundAlerts = FALSE;
extern bool eMailAlerts = FALSE;
extern bool AlertOnFhoCross = FALSE;
extern bool AlertOnFhoSigCross = FALSE;
extern bool AlertOnSlopeChange = FALSE;
extern string note4 = "*Sounds*";
extern string FhoSlopeSound = "***Exit***";
extern string AnalyseBuySound = "***Buy***";
extern string AnalyseSellSound = "***Sell***";
extern string FhoCrossSound = "***cross***";
extern string note5 = "=Alarm labels=";
extern int AnalyzeLabelWindow = 0;
extern int AnalyseLabelCorner = 1;
extern bool AnalyzeLabelonoff = FALSE;
extern string noteBox = "Other Parameters";
double Gd_284 = 0.0;
extern string note5a = "=Bars=";
extern int Fhonum_bars = 750;
int Gi_304 = 0;
int Gi_308 = 0;
double Gd_312 = 1.2;
double G_ibuf_320[];
double G_ibuf_324[];
double G_ibuf_328[];
double G_ibuf_332[];
double G_ibuf_336[];
double G_ibuf_340[];
double Gd_344;
double Gd_352;
int G_bars_360;
string Gs_364;
string Gs_372;
datetime G_time_380;
datetime G_time_384;
extern string note6 = "*** Divergence Settings ***";
extern int NumberOfDivergenceBars = 500;
extern bool drawPriceTrendLines = FALSE;
extern bool drawIndicatorTrendLines = FALSE;
extern bool ShowIn1MChart = TRUE;
extern string note7 = "--- Divergence Alert Settings ---";
extern bool EnableAlerts = FALSE;
extern string _Info1 = "";
extern string _Info2 = "------------------------------------";
extern string _Info3 = "SoundAlertOnDivergence only works";
extern string _Info4 = "when EnableAlerts is true.";
extern string _Info5 = "";
extern string _Info6 = "If SoundAlertOnDivergence is true,";
extern string _Info7 = "then sound alert will be generated,";
extern string _Info8 = "otherwise a pop-up alert will be";
extern string _Info9 = "generated.";
extern string _Info10 = "------------------------------------";
extern string _Info11 = "";
extern bool SoundAlertOnDivergence = FALSE;
extern bool EmailDivergenceAlerts = FALSE;
extern string note8 = "--- Divergence Color Settings ---";
extern color BullishDivergenceColor = DodgerBlue;
extern color BearishDivergenceColor = FireBrick;
extern string note9 = "--- Divergence Sound Files ---";
extern string ClassicBullDivSound = "CBullishDiv";
extern string ReverseBullDivSound = "RBullishDiv";
extern string ClassicBearDivSound = "CBearishDiv";
extern string ReverseBearDivSound = "RBearishDiv";
double G_ibuf_576[];
double G_ibuf_580[];

int init() {
   IndicatorBuffers(8);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(0, G_ibuf_324);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(1, G_ibuf_328);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(2, G_ibuf_336);
   SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(3, G_ibuf_340);
   SetIndexBuffer(4, G_ibuf_576);
   SetIndexBuffer(5, G_ibuf_580);
   SetIndexStyle(4, DRAW_ARROW);
   SetIndexStyle(5, DRAW_ARROW);
   SetIndexArrow(4, 110);
   SetIndexArrow(5, 110);
   SetIndexDrawBegin(5, 9);
   IndicatorDigits(Digits + 2);
   SetIndexBuffer(6, G_ibuf_332);
   SetIndexBuffer(7, G_ibuf_320);

   return (0);
}

int deinit() {
   DeleteObjects("BC");
   Comment("");
   return (0);
}

void drawLine(string A_name_0, double A_price_8, color A_color_16, int A_style_20) {
   if (WindowFind(Gs_372) > -1) {
      ObjectDelete(A_name_0);
      ObjectCreate(A_name_0, OBJ_HLINE, WindowFind(Gs_364), Time[0], A_price_8);
      ObjectSet(A_name_0, OBJPROP_STYLE, A_style_20);
      ObjectSet(A_name_0, OBJPROP_COLOR, A_color_16);
      ObjectSet(A_name_0, OBJPROP_WIDTH, 1);
   }
}

void DeleteObjects(string As_0) {
   string name_8;
   for (int Li_16 = ObjectsTotal() - 1; Li_16 >= 0; Li_16--) {
      name_8 = ObjectName(Li_16);
      if (StringFind(name_8, As_0) > -1) ObjectDelete(name_8);
   }
}

int start() {
   double Ld_0;
   string Ls_8;
   string Ls_unused_16;
   if (WindowFind(Gs_372) > -1) {
   }
   if (Period() == PERIOD_M1) Ld_0 = 0.00018;
   if (Period() == PERIOD_M5) Ld_0 = 0.00025;
   if (Period() == PERIOD_M15) Ld_0 = 0.0005;
   if (Period() == PERIOD_M30) Ld_0 = 0.008;
   if (Period() == PERIOD_H1) Ld_0 = 0.0012;
   if (Period() == PERIOD_H4) Ld_0 = 0.003;
   if (Period() == PERIOD_D1) Ld_0 = 0.005;
   if (Period() == PERIOD_W1) Ld_0 = 0.08;
   if (Period() == PERIOD_MN1) Ld_0 = 0.015;
   if (Gd_284 > 0.0) Ld_0 = Gd_284;
   double Ld_24 = Ld_0;
   double Ld_32 = -1.0 * Ld_0;
   if (WindowFind(Gs_372) > -1) {
      drawLine("BC" + "line_HL", Ld_24, HighLine_Color, Line_Style);
      drawLine("BC" + "line_ZL", 0, ZeroLine_Color, Line_Style);
      drawLine("BC" + "line_LL", Ld_32, LowLine_Color, Line_Style);
   }
   int Li_40 = 0;
   double Ld_44 = 0;
   double Ld_52 = 0;
   double Ld_unused_60 = 0;
   double Ld_68 = 0;
   double Ld_76 = 0;
   double Ld_84 = 0;
   double Ld_92 = 0;
   double Ld_100 = 0;
   double Ld_108 = 0;
   double Ld_116 = 0;
   double Ld_124 = 0;
   double Ld_132 = 0;
   double Ld_140 = 0;
   double Ld_148 = 0;
   double Ld_156 = 0;
   double Ld_164 = 0;
   double Ld_172 = 0;
   double Ld_180 = 0;
   double Ld_188 = 0;
   double Ld_196 = 0;
   double Ld_204 = 0;
   double Ld_212 = 0;
   double Ld_220 = 0;
   double Ld_228 = 0;
   double Ld_236 = 0;
   double Ld_244 = 0;
   double Ld_252 = 0;
   double Ld_260 = 0;
   double Ld_268 = 0;
   double Ld_276 = 0;
   double Ld_284 = 0;
   double Ld_292 = 0;
   double Ld_300 = 0;
   double Ld_308 = 0;
   double Ld_316 = 0;
   double Ld_324 = 0;
   double Ld_332 = 0;
   double Ld_340 = 0;
   double Ld_348 = 0;
   double Ld_356 = 0;
   double Ld_364 = 1;
   double Ld_372 = 0;
   double bars_380 = 0;
   double Ld_388 = 0;
   double Ld_396 = 0;
   double Ld_404 = 0;
   double Ld_412 = 0;
   string Ls_420 = "*";
   int ind_counted_428 = IndicatorCounted();
   bool Li_432 = TRUE;
   Ld_396 = Fhonum_bars + Gi_124 + Gi_304 + Gi_128 + Gi_308 + Gd_312;
   if (Ld_396 == Ld_404 && Ls_420 == Symbol() && Ld_412 == Time[4] - Time[5] && Bars - bars_380 < 2.0) Ld_388 = Bars - bars_380;
   else Ld_388 = -1;
   Ls_420 = Symbol();
   Ld_412 = Time[4] - Time[5];
   bars_380 = Bars;
   Ld_404 = Ld_396;
   if (Ld_388 == 1.0 || Ld_388 == 0.0) Ld_372 = Ld_388;
   else Ld_364 = 1;
   if ((!ShowIn1MChart) && Period() == PERIOD_M1) Li_432 = FALSE;
   if (Ld_364 == 1.0) {
      Ld_348 = Gd_312 * Gd_312;
      Ld_356 = Ld_348 * Gd_312;
      Ld_132 = -Ld_356;
      Ld_140 = 3.0 * (Ld_348 + Ld_356);
      Ld_148 = -3.0 * (2.0 * Ld_348 + Gd_312 + Ld_356);
      Ld_156 = 3.0 * Gd_312 + 1.0 + Ld_356 + 3.0 * Ld_348;
      Ld_308 = Gi_124;
      if (Ld_308 < 1.0) Ld_308 = 1;
      Ld_308 = (Ld_308 - 1.0) / 2.0 + 1.0;
      Ld_316 = 2 / (Ld_308 + 1.0);
      Ld_324 = 1 - Ld_316;
      Ld_308 = Gi_128;
      if (Ld_308 < 1.0) Ld_308 = 1;
      Ld_308 = (Ld_308 - 1.0) / 2.0 + 1.0;
      Ld_332 = 2 / (Ld_308 + 1.0);
      Ld_340 = 1 - Ld_332;
      G_ibuf_320[Fhonum_bars - 1] = 0;
      Ld_260 = 0;
      Ld_268 = 0;
      Ld_276 = 0;
      Ld_284 = 0;
      Ld_292 = 0;
      Ld_300 = 0;
      G_ibuf_332[Fhonum_bars - 1] = 0;
      Ld_164 = 0;
      Ld_172 = 0;
      Ld_180 = 0;
      Ld_188 = 0;
      Ld_196 = 0;
      Ld_204 = 0;
      Ld_372 = Fhonum_bars - 2;
      Ld_364 = 0;
   }
   for (Li_40 = Ld_372; Li_40 >= 0; Li_40--) {
      if (Gi_304 == 1) Ld_212 = Ld_316 * Open[Li_40] + Ld_324 * Ld_260;
      else Ld_212 = Ld_316 * Close[Li_40] + Ld_324 * Ld_260;
      Ld_220 = Ld_316 * Ld_212 + Ld_324 * Ld_268;
      Ld_228 = Ld_316 * Ld_220 + Ld_324 * Ld_276;
      Ld_236 = Ld_316 * Ld_228 + Ld_324 * Ld_284;
      Ld_244 = Ld_316 * Ld_236 + Ld_324 * Ld_292;
      Ld_252 = Ld_316 * Ld_244 + Ld_324 * Ld_300;
      Ld_44 = Ld_132 * Ld_252 + Ld_140 * Ld_244 + Ld_148 * Ld_236 + Ld_156 * Ld_228;
      if ((Ld_388 == 1.0 && Li_40 == 1) || Ld_388 == -1.0) {
         Ld_260 = Ld_212;
         Ld_268 = Ld_220;
         Ld_276 = Ld_228;
         Ld_284 = Ld_236;
         Ld_292 = Ld_244;
         Ld_300 = Ld_252;
      }
      Ld_84 = Ld_332 * Close[Li_40] + Ld_340 * Ld_164;
      Ld_92 = Ld_332 * Ld_84 + Ld_340 * Ld_172;
      Ld_100 = Ld_332 * Ld_92 + Ld_340 * Ld_180;
      Ld_108 = Ld_332 * Ld_100 + Ld_340 * Ld_188;
      Ld_116 = Ld_332 * Ld_108 + Ld_340 * Ld_196;
      Ld_124 = Ld_332 * Ld_116 + Ld_340 * Ld_204;
      Ld_68 = Ld_132 * Ld_124 + Ld_140 * Ld_116 + Ld_148 * Ld_108 + Ld_156 * Ld_100;
      if (Gi_308 == 1) {
         G_ibuf_320[Li_40] = (Ld_44 - Ld_52) / Ld_52 + (Ld_68 - Ld_76) / Ld_76;
         G_ibuf_332[Li_40] = (Ld_44 - Ld_52) / Ld_52;
         Gd_352 = G_ibuf_332[Li_40];
      } else {
         if (Ld_76 > 0.0 && Ld_52 > 0.0) {
            G_ibuf_320[Li_40] = (Ld_68 - Ld_76) / Ld_76;
            G_ibuf_332[Li_40] = (Ld_44 - Ld_52) / Ld_52;
            Gd_352 = G_ibuf_332[Li_40];
         }
      }
      G_ibuf_324[Li_40] = EMPTY_VALUE;
      G_ibuf_328[Li_40] = EMPTY_VALUE;
      if (G_ibuf_320[Li_40 + 1] < G_ibuf_320[Li_40]) {
         if (G_ibuf_324[Li_40 + 1] == EMPTY_VALUE) G_ibuf_324[Li_40 + 1] = G_ibuf_320[Li_40 + 1];
         G_ibuf_324[Li_40] = G_ibuf_320[Li_40];
      } else {
         if (G_ibuf_320[Li_40 + 1] > G_ibuf_320[Li_40]) {
            if (G_ibuf_328[Li_40 + 1] == EMPTY_VALUE) G_ibuf_328[Li_40 + 1] = G_ibuf_320[Li_40 + 1];
            G_ibuf_328[Li_40] = G_ibuf_320[Li_40];
         }
      }
      G_ibuf_336[Li_40] = EMPTY_VALUE;
      G_ibuf_340[Li_40] = EMPTY_VALUE;
      if (G_ibuf_332[Li_40 + 1] < G_ibuf_332[Li_40]) {
         if (G_ibuf_336[Li_40 + 1] == EMPTY_VALUE) G_ibuf_336[Li_40 + 1] = G_ibuf_332[Li_40 + 1];
         G_ibuf_336[Li_40] = G_ibuf_332[Li_40];
      } else {
         if (G_ibuf_332[Li_40 + 1] > G_ibuf_332[Li_40]) {
            if (G_ibuf_340[Li_40 + 1] == EMPTY_VALUE) G_ibuf_340[Li_40 + 1] = G_ibuf_332[Li_40 + 1];
            G_ibuf_340[Li_40] = G_ibuf_332[Li_40];
         }
      }
      if ((Ld_388 == 1.0 && Li_40 == 1) || Ld_388 == -1.0) {
         Ld_52 = Ld_44;
         Ld_76 = Ld_68;
         Ld_164 = Ld_84;
         Ld_172 = Ld_92;
         Ld_180 = Ld_100;
         Ld_188 = Ld_108;
         Ld_196 = Ld_116;
         Ld_204 = Ld_124;
      }
      if (Li_40 <= NumberOfDivergenceBars && Li_432) {
         CatchBullishDivergence(Li_40 + 2);
         CatchBearishDivergence(Li_40 + 2);
      }
   }
   if (Gd_352 > 0.0) {
      if (WindowFind(Gs_372) > -1) {
         if (Gd_352 < 0.0) {
            if (WindowFind(Gs_372) > -1) {
            }
         }
      }
   }
   if (Gd_344 < 0.0 && Gd_352 > 0.0) {
      if (AlertOnFhoCross)
         if (SoundAlerts) PlaySound(FhoCrossSound);
   }
   Gd_344 = Gd_352;
   if (AlertOnFhoSigCross) {
      if (G_ibuf_332[2] < G_ibuf_320[2] && G_ibuf_332[1] > G_ibuf_320[1] && G_bars_360 < Bars) {
         if (AnalyzeLabelonoff) Ls_unused_16 = "Buy";
         if (WindowFind(Gs_372) > -1) Ls_8 = Gs_364 + " " + Symbol() + " " + TF2Str(Period()) + " BUY ALARM @ " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES);
         DoAlerts(Ls_8, Ls_8);
         G_bars_360 = Bars;
         if (SoundAlerts) PlaySound(AnalyseBuySound);
      } else {
         if (G_ibuf_332[2] > G_ibuf_320[2] && G_ibuf_332[1] < G_ibuf_320[1] && G_bars_360 < Bars) {
            if (AnalyzeLabelonoff) Ls_unused_16 = "Sell";
            if (WindowFind(Gs_372) > -1) Ls_8 = Gs_364 + " " + Symbol() + " " + TF2Str(Period()) + " SELL ALARM @ " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES);
            DoAlerts(Ls_8, Ls_8);
            G_bars_360 = Bars;
            if (SoundAlerts) PlaySound(AnalyseSellSound);
         }
      }
   }
   if (AlertOnSlopeChange) {
      if (G_ibuf_332[1] > G_ibuf_320[1] && G_ibuf_336[2] != EMPTY_VALUE && G_ibuf_336[1] == EMPTY_VALUE && G_bars_360 < Bars) {
         if (AnalyzeLabelonoff) Ls_unused_16 = "Exit";
         if (ObjectFind("Crossing" + Time[0]) == -1) {
         }
         Ls_8 = Gs_364 + " " + Symbol() + " " + TF2Str(Period()) + "EXIT@ " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES);
         DoAlerts(Ls_8, Ls_8);
         G_bars_360 = Bars;
         if (SoundAlerts) PlaySound(FhoSlopeSound);
      } else {
         if (G_ibuf_332[1] < G_ibuf_320[1] && G_ibuf_340[2] != EMPTY_VALUE && G_ibuf_340[1] == EMPTY_VALUE && G_bars_360 < Bars) {
            if (AnalyzeLabelonoff) Ls_unused_16 = "Exit";
            if (ObjectFind("Crossing" + Time[0]) == -1) {
               if (AnalyzeLabelonoff) {
               }
            }
            Ls_8 = Gs_364 + " " + Symbol() + " " + TF2Str(Period()) + "EXIT @ " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES);
            DoAlerts(Ls_8, Ls_8);
            G_bars_360 = Bars;
            if (SoundAlerts) PlaySound(FhoSlopeSound);
         }
      }
      if (ObjectFind("Crossing" + Time[1]) != -1) ObjectDelete("Crossing" + Time[1]);
   }
   return (0);
}

void DoAlerts(string As_0, string As_8) {
   if (MsgAlerts) Alert(As_8);
   if (eMailAlerts) SendMail(As_0, As_8);
}

string TF2Str(int Ai_0) {
   switch (Ai_0) {
   case 1:
      return ("M1");
   case 5:
      return ("M5");
   case 15:
      return ("M15");
   case 30:
      return ("M30");
   case 60:
      return ("H1");
   case 240:
      return ("H4");
   case 1440:
      return ("D1");
   case 10080:
      return ("W1");
   case 43200:
      return ("MN");
   }
   return (Period());
}

void CatchBullishDivergence(int Ai_0) {
   int Li_4;
   int Li_8;
   if (IsIndicatorTrough(Ai_0) != 0) {
      Li_4 = Ai_0;
      Li_8 = GetIndicatorLastTrough(Ai_0);
      if (G_ibuf_332[Li_4] > G_ibuf_332[Li_8] && Low[Li_4] < Low[Li_8]) {
         G_ibuf_576[Li_4] = G_ibuf_332[Li_4] - 0.0001;
         if (drawPriceTrendLines == TRUE) DrawPriceTrendLine(Time[Li_4], Time[Li_8], Low[Li_4], Low[Li_8], BullishDivergenceColor, STYLE_SOLID);
         if (drawIndicatorTrendLines == TRUE) DrawIndicatorTrendLine(Time[Li_4], Time[Li_8], G_ibuf_332[Li_4], G_ibuf_332[Li_8], BullishDivergenceColor, STYLE_SOLID);
         if (EnableAlerts == TRUE) {
            if (SoundAlertOnDivergence == TRUE) SoundAlert(ClassicBullDivSound, Li_4);
            else DisplayAlert("Classical bullish divergence on: ", Li_4);
         }
      }
      if (G_ibuf_332[Li_4] < G_ibuf_332[Li_8] && Low[Li_4] > Low[Li_8]) {
         G_ibuf_576[Li_4] = G_ibuf_332[Li_4] - 0.0001;
         if (drawPriceTrendLines == TRUE) DrawPriceTrendLine(Time[Li_4], Time[Li_8], Low[Li_4], Low[Li_8], BullishDivergenceColor, STYLE_DOT);
         if (drawIndicatorTrendLines == TRUE) DrawIndicatorTrendLine(Time[Li_4], Time[Li_8], G_ibuf_332[Li_4], G_ibuf_332[Li_8], BullishDivergenceColor, STYLE_DOT);
         if (EnableAlerts == TRUE) {
            if (SoundAlertOnDivergence == TRUE) {
               SoundAlert(ReverseBullDivSound, Li_4);
               return;
            }
            DisplayAlert("Reverse bullish divergence on: ", Li_4);
         }
      }
   }
}

void CatchBearishDivergence(int Ai_0) {
   int Li_4;
   int Li_8;
   if (IsIndicatorPeak(Ai_0) != 0) {
      Li_4 = Ai_0;
      Li_8 = GetIndicatorLastPeak(Ai_0);
      if (G_ibuf_332[Li_4] < G_ibuf_332[Li_8] && High[Li_4] > High[Li_8]) {
         G_ibuf_580[Li_4] = G_ibuf_332[Li_4] + 0.0001;
         if (drawPriceTrendLines == TRUE) DrawPriceTrendLine(Time[Li_4], Time[Li_8], High[Li_4], High[Li_8], BearishDivergenceColor, STYLE_SOLID);
         if (drawIndicatorTrendLines == TRUE) DrawIndicatorTrendLine(Time[Li_4], Time[Li_8], G_ibuf_332[Li_4], G_ibuf_332[Li_8], BearishDivergenceColor, STYLE_SOLID);
         if (EnableAlerts == TRUE) {
            if (SoundAlertOnDivergence == TRUE) SoundAlert(ClassicBearDivSound, Li_4);
            else DisplayAlert("Classical bearish divergence on: ", Li_4);
         }
      }
      if (G_ibuf_332[Li_4] > G_ibuf_332[Li_8] && High[Li_4] < High[Li_8]) {
         G_ibuf_580[Li_4] = G_ibuf_332[Li_4] + 0.0001;
         if (drawPriceTrendLines == TRUE) DrawPriceTrendLine(Time[Li_4], Time[Li_8], High[Li_4], High[Li_8], BearishDivergenceColor, STYLE_DOT);
         if (drawIndicatorTrendLines == TRUE) DrawIndicatorTrendLine(Time[Li_4], Time[Li_8], G_ibuf_332[Li_4], G_ibuf_332[Li_8], BearishDivergenceColor, STYLE_DOT);
         if (EnableAlerts == TRUE) {
            if (SoundAlertOnDivergence == TRUE) {
               SoundAlert(ReverseBearDivSound, Li_4);
               return;
            }
            DisplayAlert("Reverse bearish divergence on: ", Li_4);
         }
      }
   }
}

int IsIndicatorTrough(int Ai_0) {
   if (G_ibuf_332[Ai_0] <= G_ibuf_332[Ai_0 + 1] && G_ibuf_332[Ai_0] < G_ibuf_332[Ai_0 + 2] && G_ibuf_332[Ai_0] < G_ibuf_332[Ai_0 - 1]) return (1);
   return (0);
}

int GetIndicatorLastTrough(int Ai_0) {
   for (int Li_4 = Ai_0 + 5; Li_4 < Bars; Li_4++) {
      if (G_ibuf_320[Li_4] <= G_ibuf_320[Li_4 + 1] && G_ibuf_320[Li_4] <= G_ibuf_320[Li_4 + 2] && G_ibuf_320[Li_4] <= G_ibuf_320[Li_4 - 1] && G_ibuf_320[Li_4] <= G_ibuf_320[Li_4 - 2]) {
         for (int Li_ret_8 = Li_4; Li_ret_8 < Bars; Li_ret_8++)
            if (G_ibuf_332[Li_ret_8] <= G_ibuf_332[Li_ret_8 + 1] && G_ibuf_332[Li_ret_8] < G_ibuf_332[Li_ret_8 + 2] && G_ibuf_332[Li_ret_8] <= G_ibuf_332[Li_ret_8 - 1] && G_ibuf_332[Li_ret_8] < G_ibuf_332[Li_ret_8 - 2]) return (Li_ret_8);
      }
   }
   return (-1);
}

void DrawPriceTrendLine(int A_datetime_0, int A_datetime_4, double A_price_8, double A_price_16, color A_color_24, double A_style_28) {
   string name_36 = "FHODiv" + "6" + "_FHO_DivergenceLine_# " + DoubleToStr(A_datetime_0, 0);
   ObjectDelete(name_36);
   ObjectCreate(name_36, OBJ_TREND, 0, A_datetime_0, A_price_8, A_datetime_4, A_price_16, 0, 0);
   ObjectSet(name_36, OBJPROP_RAY, FALSE);
   ObjectSet(name_36, OBJPROP_COLOR, A_color_24);
   ObjectSet(name_36, OBJPROP_STYLE, A_style_28);
}

void DrawIndicatorTrendLine(int A_datetime_0, int A_datetime_4, double A_price_8, double A_price_16, color A_color_24, double A_style_28) {
   string name_36;
   int window_44 = WindowFind(Gs_372);
   if (window_44 >= 0) {
      name_36 = "FHODiv" + "6" + "_FHO_DivergenceLine_$# " + DoubleToStr(A_datetime_0, 0);
      ObjectDelete(name_36);
      ObjectCreate(name_36, OBJ_TREND, window_44, A_datetime_0, A_price_8, A_datetime_4, A_price_16, 0, 0);
      ObjectSet(name_36, OBJPROP_RAY, FALSE);
      ObjectSet(name_36, OBJPROP_COLOR, A_color_24);
      ObjectSet(name_36, OBJPROP_STYLE, A_style_28);
   }
}

void DisplayAlert(string As_0, int Ai_8) {
   string Ls_unused_12;
   string Ls_20;
   if (Ai_8 <= 2 && Time[Ai_8] != G_time_380) {
      G_time_380 = Time[Ai_8];
      Alert(As_0, Symbol(), " , ", TF2Str(Period()), " minutes chart");
      Ls_20 = "Divergence on " + TF2Str(Period());
      if (EmailDivergenceAlerts) SendMail(Ls_20, As_0);
   }
}

void SoundAlert(string As_0, int Ai_8) {
   if (Ai_8 <= 2 && Time[Ai_8] != G_time_384) {
      G_time_384 = Time[Ai_8];
      PlaySound(As_0);
   }
}

int IsIndicatorPeak(int Ai_0) {
   if (G_ibuf_332[Ai_0] >= G_ibuf_332[Ai_0 + 1] && G_ibuf_332[Ai_0] > G_ibuf_332[Ai_0 + 2] && G_ibuf_332[Ai_0] > G_ibuf_332[Ai_0 - 1]) return (1);
   return (0);
}

int GetIndicatorLastPeak(int Ai_0) {
   for (int Li_4 = Ai_0 + 5; Li_4 < Bars; Li_4++) {
      if (G_ibuf_320[Li_4] >= G_ibuf_320[Li_4 + 1] && G_ibuf_320[Li_4] >= G_ibuf_320[Li_4 + 2] && G_ibuf_320[Li_4] >= G_ibuf_320[Li_4 - 1] && G_ibuf_320[Li_4] >= G_ibuf_320[Li_4 - 2]) {
         for (int Li_ret_8 = Li_4; Li_ret_8 < Bars; Li_ret_8++)
            if (G_ibuf_332[Li_ret_8] >= G_ibuf_332[Li_ret_8 + 1] && G_ibuf_332[Li_ret_8] > G_ibuf_332[Li_ret_8 + 2] && G_ibuf_332[Li_ret_8] >= G_ibuf_332[Li_ret_8 - 1] && G_ibuf_332[Li_ret_8] > G_ibuf_332[Li_ret_8 - 2]) return (Li_ret_8);
      }
   }
   return (-1);
}
